/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_COMBO_BOX_SPIN_H__
#define __TK_EXP_COMBO_BOX_SPIN_H__

#include <gtkmm.h>

#include "libtkcommon/string.h"

namespace Tk {
  namespace Experimenter {

    class ComboBoxSpin : public Gtk::ComboBox
      {
      private:
	class Columns : public Gtk::TreeModel::ColumnRecord
	  {
	  public:
	    Gtk::TreeModelColumn<double> numerical_value;
	    Gtk::TreeModelColumn<Glib::ustring> description;
	    Columns() { add(numerical_value); add(description); }
	  };
	
	guint                        _digits;
	Columns                      _columns;
	Glib::RefPtr<Gtk::ListStore> _store;
	
	String get_value_description(double value);
	void combo_change_handler();
	
      protected:
	Gtk::SpinButton              _spin;
      public:
	ComboBoxSpin(double climb_rate = 0.0,
		     guint digits = 0);
	void set_adjustment(Gtk::Adjustment &adj);

	void add_value(double value, const String *description = 0);
	double get_value() const;
	void set_value(double value);
      };

  } /* namespace Experimenter */
}; /* namespace Tk */

#endif /* __TK_EXP_COMBO_BOX_SPIN_H__ */
