/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_FLASH_TOGGLE_TOOL_H__
#define __TK_EXP_FLASH_TOGGLE_TOOL_H__

#include <gtkmm.h>

namespace Tk {
  namespace Experimenter {

    class FlashToggleTool : public Gtk::ToggleToolButton
      {
      private:
	/*	Gtk::Image *              _image;
	Glib::RefPtr<Gdk::Pixbuf> _normal_icon;
	Glib::RefPtr<Gdk::Pixbuf> _flash_icon;*/
	
	Gtk::Image                _normal_icon;
	Gtk::Image                _flash_icon;

	sigc::connection          _flash_signal;
	bool                      _on;
	
	bool signal();
	void on();
	void off();
      public:
	FlashToggleTool(const Gtk::StockID &stock_id,
			const Gtk::IconSize &icon_size,
			const Gdk::Color& flash_colour);
	
	void flash_start(unsigned long interval);
	void flash_stop();
      };
      
  } /* namespace Experimenter */
}; /* namespace Tk */




#endif /* __TK_EXP_FLASH_TOGGLE_TOOL_H__ */
