/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007, 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXP_INTENT_CHOOSER_H__
#define __TK_EXP_INTENT_CHOOSER_H__

#include <gtkmm.h>

#include "libtkcommon/value.h"
#include "intent_selector.h"

namespace Tk {
  namespace Experimenter {

    class Variables : public Gtk::Dialog
      {
      private:
	IntentSelector _intent_list;
	Gtk::CheckButton _ability_rating_set;
	Gtk::Adjustment _ability_rating;
	Gtk::HScale _ability_rating_slider;
	
	void refresh_active();
      public:
        Variables(Db::Database *database,
		  Gtk::Window &parent,
		  unsigned trace_count,
		  const String &algorithm_spec,
		  bool test);
	Db::Code get_intent_code();
	Double get_ability_rating();
      };
      
  } /* namespace Experimenter */
}; /* namespace Tk */




#endif /* __TK_EXP_INTENT_CHOOSER_H__ */
