/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_EXCEPTIONS_H__
#define __TK_EXCEPTIONS_H__

#include <cstring>
#include <string>
#include <stdexcept>

namespace Tk {

  class UnixError : public std::runtime_error
  {
  public:
    UnixError (const std::string & prefix, int err)
      : runtime_error (prefix + ": " + strerror (err)) {}
  };
};


#endif /* __TK_EXCEPTIONS_H__ */
