/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_DOMAIN_H__
#define __TK_DB_DOMAIN_H__

#include <map>

#include <boost/assign/list_of.hpp>

#include "libtkcommon/string.h"

namespace Tk {
  namespace Db {
    
    typedef std::map<Tk::String, Tk::String> DomainMap;
    
    const DomainMap domains = boost::assign::map_list_of
      ("experiment", "Experiment")
      ("operator",   "Operator")
      ("location",   "Location");
    
    const Tk::String &get_domain_label(const Tk::String &domain);
    
  }; /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DB_DOMAIN_H__ */
