/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkdb/experiment_result.h"

using namespace Tk::Db;

ExperimentResult:: ExperimentResult(const Id &location_id,
				    const Ids &operators,
				    Data::ValueMap *properties,
				    Tk::Resolver::Result *result)
  : _location_id(location_id),
    _operators(operators),
    _properties(properties),
    _result(result)
{
}

ExperimentResult:: ~ExperimentResult()
{
  delete _result;
  if (_properties)
    delete _properties;
}

const Id &
ExperimentResult:: get_location_id() const
{
  return _location_id;
}

const Ids &
ExperimentResult:: get_operators() const
{
  return _operators;
}

Data::ValueMap *
ExperimentResult:: take_properties()
{
  Data::ValueMap *p(_properties);
  _properties = 0;
  return p;
}

const Tk::Resolver::Result &
ExperimentResult:: get_result() const
{
  return *_result;
}
