/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DATABASE_TYPES_H__
#define __TK_DATABASE_TYPES_H__

#include <memory>

#include <odbc++/types.h>
#include <odbc++/resultset.h>

#include "libtkcommon/string.h"
#include "libtkcommon/value.h"
#include "libtkresolver/types.h"
#include "libtkdb/data_set.h"

namespace Tk {
  namespace Db {
    
    typedef odbc::Types::SQLType Type;
    typedef odbc::Long Id;
    typedef std::list<Id> Ids;
    typedef ODBCXX_STRING String;
    typedef odbc::Date Date;
    typedef odbc::Timestamp DateTime;
    typedef Tk::Value<odbc::Timestamp> DateTimeValue;
    
    typedef odbc::Statement Statement;
    typedef std::auto_ptr<Statement> StatementPtr;
    typedef odbc::PreparedStatement PStatement;
    typedef std::auto_ptr<PStatement> PStatementPtr;
    
    typedef std::auto_ptr<DataSet>  DataSetPtr;
    
    typedef String Code;
    typedef Tk::Value<Code> CodeValue;
    typedef std::list<Code> Codes;
    
    typedef std::pair<Code, Tk::String> IntentInfo;
    typedef std::list<IntentInfo> IntentInfoList;
    
  }; /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DATABASE_TYPES_H__ */
