/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "libtkdbui/boolean_value.h"

#include "libtkcommon/intl.h"

using namespace Tk::Db::Ui;
    
BooleanValue:: BooleanValue(const Tk::Bool &source)
  : Value(Tk::Db::Data::Boolean),
    Gtk::ToggleButton(Gtk::Stock::YES)
{
  set_tooltip_text(_("The boolean value of the datum"));
  if (source.is_valid())
    set_active(source.get_value());
}

void
BooleanValue:: on_toggled()
{
  value_changed();
}

Tk::Db::Data::Value
BooleanValue:: get_value() const
{
  return get_active();
}
