/* -*- c++ -*-
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2008 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __TK_DB_UI_NUMERIC_VALUE_H__
#define __TK_DB_UI_NUMERIC_VALUE_H__

#include <gtkmm.h>

#include "libtkdbui/value.h"

namespace Tk {
  namespace Db {
    namespace Ui {
      
      class NumericValue : public Tk::Db::Ui::Value, public Gtk::SpinButton
      {
      private:
	Gtk::Adjustment _adjustment;
	void init(const Tk::Db::Data::Datum *value);
	virtual void on_changed();
	
      public:
	NumericValue(const Tk::Db::Data::Value &value);
	NumericValue(const Tk::Db::Data::Type &type);
	virtual Tk::Db::Data::Value get_value() const;
      };
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace Tk */

#endif /* __TK_DB_UI_NUMERIC_VALUE_H__ */
