/*
 * TkResolver++ - Psychokinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE
#endif

#include <wchar.h>

#include <stdlib.h>
#include <getopt.h>

#include "libtkcommon/debug.h"
#include "libtkrandom/rng.h"

using namespace Tk::Random;

static const Tk::String RETRIEVER_NAME("quantis");


void
test_value(unsigned long upper)
{
  unsigned long value;
  value = random<unsigned long>(upper, RETRIEVER_NAME);
  DEBUG_OUT << "upper: "
	    << upper
	    << "; value: "
	    << value
	    << std::endl;
}

void
test_average(unsigned long upper, unsigned n)
{
  unsigned long avg = 0;
  for (unsigned i = 0; i < n; ++i)
    avg += random<unsigned long>(upper, RETRIEVER_NAME);

  avg /= n;

  /*
  DEBUG_OUT << "upper: "
	    << upper
	    << "; n: "
	    << n
	    << "; average: "
	    << avg
	    << std::endl;
  */
  std::cout << avg << std::endl;
}

int
main (int argc, char ** argv)
{
  Glib::thread_init();

  /*  for (unsigned long upper(30000);
       upper < 20000000;
       upper += 100000)
    {
      test_upper(upper);
      }*/

  //  for (unsigned long upper(10); upper < 20; ++upper)
  //    test_value(upper);

  /*
  for (unsigned i = 0; i < 10; ++i)
    test_value(20);

  for (unsigned short i = 0; i < 5; ++i)
  test_average(10, 10);
  for (unsigned short i = 0; i < 5; ++i)
    test_average(100, 100);
  */
  for (unsigned short i = 0; i < 1000000; ++i)
    test_average(1000, 1000);
  /*
  for (unsigned short i = 0; i < 10; ++i)
  test_average(10000, 10000);
  for (unsigned short i = 0; i < 20; ++i)
  test_average(100000, 100000);
  */

  return 0;
}
